import { useEffect } from 'react';

/**
 * 关闭页面时 , 提示用户
 * @param enabled {boolean} 是否开启
 * @param message {string} 自定义退出信息 部分浏览器不能改变
 */
var useBeforeUnload = function useBeforeUnload() {
  var enabled = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
  var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '真的要离开吗?';
  useEffect(function () {
    var prevOnbeforeunload = window.onbeforeunload;
    if (!enabled) {
      window.onbeforeunload = prevOnbeforeunload;
      return;
    }

    // const handler = (event: BeforeUnloadEvent) => {
    //   event.preventDefault();
    //   if (message) {
    //     event.returnValue = message;
    //   }
    //   return message;
    // };
    // window.addEventListener('beforeunload', handler);
    // return () => window.removeEventListener('beforeunload', handler);

    window.onbeforeunload = function (event) {
      event.preventDefault();
      if (prevOnbeforeunload) {
        prevOnbeforeunload === null || prevOnbeforeunload === void 0 ? void 0 : prevOnbeforeunload(event);
      }
      event.returnValue = message;
      return message;
    };
    return function () {
      window.onbeforeunload = prevOnbeforeunload;
    };
  }, [message, enabled]);
};
export default useBeforeUnload;