type Subscription<T> = (val: T) => void;
export declare class BusEvent<K, T> {
    private subscriptions;
    /**
     * 发布状态
     * @param {K} key 唯一的 key 值
     * @param {T} val 发布的数据
     * @memberof BusEvent
     */
    emit: (key: K, val: T) => void;
    /**
     * 订阅状态
     * @param {K} key  与 emit 中的第一参数对应, 唯一的 key 值
     * @param {Subscription<T>} callback 订阅的回调函数
     * @memberof BusEvent
     */
    subscription: (key: K, callback: Subscription<T>) => void;
}
/**
 * 基于发布订阅模式的事件总线
 * @description 多用于兄弟组件 (特别是大屏) 之间的传递数据
 * @return {BusEvent<K, T>}
 */
export default function useBusEvent<K = string | symbol, T = any>(): BusEvent<K, T>;
export {};
