function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import { useEffect, useRef } from 'react';
export var BusEvent = /*#__PURE__*/_createClass(function BusEvent() {
  var _this = this;
  _classCallCheck(this, BusEvent);
  _defineProperty(this, "subscriptions", new Map());
  /**
   * 发布状态
   * @param {K} key 唯一的 key 值
   * @param {T} val 发布的数据
   * @memberof BusEvent
   */
  _defineProperty(this, "emit", function (key, val) {
    var _iterator = _createForOfIteratorHelper(_this.subscriptions.get(key) || []),
      _step;
    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var subscription = _step.value;
        subscription(val);
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  });
  /**
   * 订阅状态
   * @param {K} key  与 emit 中的第一参数对应, 唯一的 key 值
   * @param {Subscription<T>} callback 订阅的回调函数
   * @memberof BusEvent
   */
  _defineProperty(this, "subscription", function (key, callback) {
    var callbackRef = useRef();
    callbackRef.current = callback;
    useEffect(function () {
      function subscription(val) {
        if (callbackRef.current) callbackRef.current(val);
      }
      if (!_this.subscriptions.has(key)) {
        _this.subscriptions.set(key, new Set());
        var subscriptionSet = _this.subscriptions.get(key);
        subscriptionSet.add(subscription);
      } else {
        var _subscriptionSet = _this.subscriptions.get(key);
        _subscriptionSet.add(subscription);
      }
      return function () {
        _this.subscriptions.delete(key);
      };
    }, []);
  });
});

/**
 * 基于发布订阅模式的事件总线
 * @description 多用于兄弟组件 (特别是大屏) 之间的传递数据
 * @return {BusEvent<K, T>}
 */
export default function useBusEvent() {
  var ref = useRef();
  if (!ref.current) {
    ref.current = new BusEvent();
  }
  return ref.current;
}