import { type DependencyList, type EffectCallback } from 'react';
/**
 * 只在更新时调用并且会深度比较依赖项
 * @param effect{EffectCallback} 更新时所需要调用的函数
 * @param deps{DependencyList}  更新的依赖 (深度比较依赖项)
 */
declare const useDeepUpdateEffect: (effect: EffectCallback, deps: DependencyList) => void;
export default useDeepUpdateEffect;
