function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { isFunction } from "../utils";
import { useEffect, useState } from 'react';
var PI = Math.PI;
/**方向 */
var Direction = /*#__PURE__*/function (Direction) {
  Direction["top"] = "top";
  Direction["left"] = "left";
  Direction["right"] = "right";
  Direction["bottom"] = "bottom";
  return Direction;
}(Direction || {});
/**
 * 精确的获取鼠标进入元素的方向
 * @param target dom 节点
 * @return {Direction} 鼠标进入元素的方向
 */
export default function useEnterDirection(target) {
  var _useState = useState(),
    _useState2 = _slicedToArray(_useState, 2),
    direction = _useState2[0],
    setDirection = _useState2[1];
  useEffect(function () {
    if (!target) return;
    var dom = isFunction(target) ? target === null || target === void 0 ? void 0 : target() : target === null || target === void 0 ? void 0 : target.current;
    var rect = dom === null || dom === void 0 ? void 0 : dom.getBoundingClientRect();
    var theta = Math.atan2(rect.height, rect.width);
    var mouseenter = function mouseenter(e) {
      var x = e.offsetX - rect.width / 2;
      var y = rect.height / 2 - e.offsetY;
      var d = Math.atan2(y, x);
      if (d < theta && d >= -theta) {
        setDirection(Direction.right);
      } else if (d >= theta && d < PI - theta) {
        setDirection(Direction.top);
      } else if (d >= PI - theta || d < -(PI - theta)) {
        setDirection(Direction.left);
      } else {
        setDirection(Direction.bottom);
      }
    };
    var mouseleave = function mouseleave() {
      return setDirection(void 0);
    };
    dom === null || dom === void 0 ? void 0 : dom.addEventListener('mouseenter', mouseenter);
    dom === null || dom === void 0 ? void 0 : dom.addEventListener('mouseleave', mouseleave);
    return function () {
      dom === null || dom === void 0 ? void 0 : dom.removeEventListener('mouseenter', mouseenter);
      dom === null || dom === void 0 ? void 0 : dom.removeEventListener('mouseleave', mouseleave);
    };
  }, []);
  return direction;
}