import { MutableRefObject } from 'react';
export type useLazyImageParams = {
    /** querySelectorAll抓取页面上所有可延迟加载的图像 */
    imageAttribute?: `data-${string}`;
    /** 在哪个节点下查询 querySelectorAll 默认为整个视口*/
    target?: MutableRefObject<HTMLElement | null> | (() => HTMLElement);
    /** IntersectionObserver 的配置项*/
    options?: Omit<IntersectionObserverInit, 'root'> & {
        root?: MutableRefObject<HTMLElement | null> | (() => HTMLElement);
    };
    /** 依赖项 如果配置会在更新时重新执行监听 */
    dependencies?: any[];
};
export default function useLazyImage(params?: useLazyImageParams): void;
