function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useCallback, useEffect, useLayoutEffect, useState } from 'react';
var originalOverflow = null;

/**
 * 设置锁定元素的滚动, 常用于弹窗 抽屉等组件
 * @param lock 初始是否锁定 默认为fasle
 * @param target  要锁定额度元素 默认为body
 * @return 返回锁定的状态和修改锁定的方法数组
 */
var useLockScroll = function useLockScroll() {
  var lock = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
  var target = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {
    return document.body;
  };
  var scrollW = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 17;
  var _useState = useState(lock),
    _useState2 = _slicedToArray(_useState, 2),
    locked = _useState2[0],
    setLocked = _useState2[1];
  var lockFn = useCallback(function (dom) {
    if (dom === document.body) {
      var styleDom = document.createElement('style');
      styleDom.dataset.useLockScrollState = 'true';
      styleDom.innerHTML = "\n       html body {\n          width: calc(100% - ".concat(scrollW, "px);\n          overflow: hidden;\n        }\n      ");
      document.head.appendChild(styleDom);
      return;
    }
    originalOverflow = window.getComputedStyle(dom).overflow;
    dom.style.overflow = 'hidden';
  }, []);
  var unlockFn = useCallback(function (dom) {
    if (dom === document.body) {
      var styleDom = document.head.querySelector('style[data-use-lock-scroll-state="true"]');
      if (styleDom) {
        styleDom.remove();
      }
      return;
    }
    dom.style.overflow = originalOverflow;
    originalOverflow = null;
  }, []);
  useLayoutEffect(function () {
    var dom = typeof target === 'function' ? target === null || target === void 0 ? void 0 : target() : target === null || target === void 0 ? void 0 : target.current;
    if (locked) {
      lockFn(dom);
    } else {
      unlockFn(dom);
    }
    return function () {
      originalOverflow = null;
    };
  }, [locked]);
  useEffect(function () {
    return function () {
      return setLocked(lock);
    };
  }, []);
  var updateLocked = useCallback(function (bool) {
    return setLocked(bool);
  }, []);
  return [locked, updateLocked];
};
export default useLockScroll;