function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useCallback, useEffect, useState } from 'react';
import ReactDOM from 'react-dom';
/**
 * 允许在父组件之外呈现子组件。
 * @param {HTMLElement} el 要挂载到哪个元素下面 默认body
 */
var usePortal = function usePortal() {
  var el = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : document.body;
  var _useState = useState({
      render: function render() {
        return null;
      },
      remove: function remove() {
        return null;
      }
    }),
    _useState2 = _slicedToArray(_useState, 2),
    portal = _useState2[0],
    setPortal = _useState2[1];
  var createPortalFn = useCallback(function (el) {
    var Portal = function Portal(_ref) {
      var children = _ref.children;
      return /*#__PURE__*/ReactDOM.createPortal(children, el || document.body);
    };

    // React 将从此节点移除已挂载的 React 组件(children)。
    var remove = function remove() {
      var _ReactDOM$unmountComp;
      return ReactDOM === null || ReactDOM === void 0 ? void 0 : (_ReactDOM$unmountComp = ReactDOM.unmountComponentAtNode) === null || _ReactDOM$unmountComp === void 0 ? void 0 : _ReactDOM$unmountComp.call(ReactDOM, el || document.body);
    };
    return {
      render: Portal,
      remove: remove
    };
  }, []);
  useEffect(function () {
    if (el) portal.remove();
    var newPortal = createPortalFn(el);
    setPortal(newPortal);
    return function () {
      newPortal.remove();
    };
  }, [el]);
  return portal.render;
};
export default usePortal;