/// <reference types="react" />
/**
 *用于滑块验证滑动距离的hook
 *支持 PC端 移动端 触摸笔
 * @param {((() => HTMLElement) | React.RefObject<HTMLElement>)} el 验证滑块的dom
 * @param {{ maxMoveX?: number; onMouseUp?: (moveX: number) => void }} [{
 *     maxMoveX = 400,
 *     onMouseUp,
 *   }={}]  配置项
 */
export default function useSlideVerify(el: (() => HTMLElement) | React.RefObject<HTMLElement>, { initX, maxMoveX, onMouseDown, onMouseUp, onMouseMove, }?: {
    initX?: number;
    maxMoveX?: number;
    onMouseDown?: (moveX: number) => void;
    onMouseMove?: (moveX: number) => void;
    onMouseUp?: (moveX: number) => void;
}): {
    moveX: number;
    reset: () => void;
    moveing: boolean;
};
