function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
export var Typewriter = /*#__PURE__*/function () {
  function Typewriter(onConsume) {
    var _this = this;
    var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      initStr = _ref.initStr,
      onFinish = _ref.onFinish;
    _classCallCheck(this, Typewriter);
    _defineProperty(this, "queue", []);
    _defineProperty(this, "consuming", false);
    _defineProperty(this, "timer", void 0);
    // 更改变量名为timer
    _defineProperty(this, "onFinish", function () {});
    _defineProperty(this, "onConsume", function () {});
    _defineProperty(this, "consume", function () {
      if (_this.queue.length > 0) {
        var _str = _this.queue.shift();
        if (_str) {
          try {
            _this.onConsume(_str);
          } catch (error) {
            console.error('Error occurred in onConsume callback:', error);
            // 可以选择是否要在这里终止处理
          }
        }
      } else {
        _this.done();
      }
    });
    this.onConsume = onConsume;
    this.onFinish = onFinish;
    if (initStr) {
      this.queue = initStr === null || initStr === void 0 ? void 0 : initStr.split('');
    }
  }
  _createClass(Typewriter, [{
    key: "dynamicSpeed",
    value: function dynamicSpeed() {
      if (this.queue.length === 0) return 0;
      var speed = 1500 / this.queue.length;
      if (speed > 200) {
        return 200;
      } else if (speed < 20) {
        return 20;
      } else {
        return speed;
      }
    }
  }, {
    key: "add",
    value: function add(str) {
      var _this$queue;
      if (!str) return;
      (_this$queue = this.queue).push.apply(_this$queue, _toConsumableArray(str.split('')));
    }
  }, {
    key: "next",
    value: function next() {
      var _this2 = this;
      this.consume();
      var speed = this.dynamicSpeed(); // 优化：只在需要时计算速度
      this.timer = setTimeout(function () {
        _this2.consume();
        if (_this2.consuming) {
          _this2.next();
        }
      }, speed);
    }
  }, {
    key: "start",
    value: function start() {
      this.consuming = true;
      this.next();
    }
  }, {
    key: "done",
    value: function done() {
      this.consuming = false;
      clearTimeout(this.timer);
      try {
        // 保证queue非空时才调用onConsume，避免传递空字符串
        if (this.queue.length > 0) {
          this.onConsume(this.queue.join(''));
        }
      } catch (error) {
        console.error('Error occurred in onConsume callback inside done:', error);
      }
      try {
        this.onFinish();
      } catch (error) {
        console.error('Error occurred in onFinish callback:', error);
      }
      this.queue = [];
    }
  }]);
  return Typewriter;
}();