import type { DependencyList } from 'react';
/**
 * 判断深度两个数据是否相等
 * @param aDeps
 * @param bDeps
 * @returns
 */
export declare const depsEqual: (aDeps?: DependencyList, bDeps?: DependencyList) => boolean;
/**
 * 判断是不是函数
 * @param fn{*} 需要判断的值
 * @returns
 */
export declare const isFunction: (fn: unknown) => boolean;
/**
 * 将驼峰字符串以-分割
 * @param str
 * @returns
 */
export declare function getCamelCase(str: string): string;
/**
 * 判断元素是否可滚动
 * @param  HTMLElement dom元素
 * @return boolean
 */
export declare const isScrollable: (ele: HTMLElement) => boolean;
/**
 * 查找当前元素以及父元素直到body 可以滚动的元素
 * @param HTMLElement 元素
 * @returns HTMLElement
 */
export declare const getScrollableParent: (ele: HTMLElement) => HTMLElement;
/**
 * 判断是不是苹果Safari浏览器
 */
export declare const isSafari: () => boolean;
/**
 * 判断苹果Safari屏幕的方向
 */
export declare function getScreenOrientation(): 'portrait' | 'landscape';
